#ifndef __kapp_h__
#define __kapp_h__

#include <qapplication.h>

#include <stdlib.h>

#include "kinstance.h"

#define kapp KApplication::self()

class DCOPClient;

class KApplication : public QApplication, public KInstance
{
    Q_OBJECT
public:
    KApplication( int argc, char **argv, const char *name );
    virtual ~KApplication();

    static KApplication *self() { return s_self; }

    static bool startServiceByDesktopName( const QString &, const QStringList &, QString * );

    static bool startServiceByDesktopPath( const QString & );

    DCOPClient *dcopClient() const { return m_dcopClient; }

    void invokeBrowser( const QString & ) {}
    void invokeMailer( const QString &, const QString & ) {}

    int random() { return rand(); } // ### ;-)

private:
    static KApplication *s_self;

    DCOPClient *m_dcopClient;
};

// ### FIXME: checkAccess copyright by Kalle!

bool checkAccess( const QString &pathname, int mode);

#endif
