#ifndef __kio_scheduler_h__
#define __kio_scheduler_h__

#include <qobject.h>
#include <qdict.h>
#include <qtimer.h>
#include <qlist.h>

namespace KIO
{
    class SimpleJob;
    class Slave;

    class Scheduler : public QObject
    {
        Q_OBJECT
    public:
        Scheduler();
        virtual ~Scheduler();

        bool doJob( SimpleJob *job );

        void releaseJob( SimpleJob *job, bool killSlave = false );

        static Scheduler *self();

    private slots:
        void slotStep();

    private:
        static Slave *createSlave( const QString &prot );

        struct ProtocolInfo
        {
            ProtocolInfo() { m_slave = 0; m_running = false; }

            QList<SimpleJob> m_jobs;
            bool m_running;
            Slave *m_slave;
        };

        void doStep( ProtocolInfo *nfo );

        void killSlave( ProtocolInfo *nfo );

        QTimer m_timer;
        QDict<ProtocolInfo> m_schedule;
        static Scheduler *s_self;
    };

};

#endif
