/*  This file is part of the KDE project
    Copyright (C) 2000 Simon Hausmann <hausmann@kde.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ksslinfodlg.h"

#include <qmessagebox.h>

#include <klocale.h>

KSSLInfoDlg::KSSLInfoDlg( bool secureConnection, QWidget *parent, const char */*name*/ )
{
    m_ssl = secureConnection;
    m_parent = parent;
}

void KSSLInfoDlg::show()
{
    QMessageBox::information( m_parent, i18n( "SSL Information" ),
                              m_ssl ?
                              i18n( "The current connection\n is secured with SSL." )
                              :
                              i18n( "The current connection\n is not secured with SSL." )
        );

}
